/*
 * Copyright (c) Des Herriott 1993, 1994
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 */

/* 
 * Source file cbops.c - operations prefixed by 0xCB.
 */

/* rlc_b */
case 0x00:
	carryFlag = *b & 0x80;
	*b = (*b << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*b);
	break;

/* rlc_c */
case 0x01:
	carryFlag = *c & 0x80;
	*c = (*c << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*c);
	break;

/* rlc_d */
case 0x02:
	carryFlag = *d & 0x80;
	*d = (*d << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*d);
	break;

/* rlc_e */
case 0x03:
	carryFlag = *e & 0x80;
	*e = (*e << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*e);
	break;

/* rlc_h */
case 0x04:
	carryFlag = *h & 0x80;
	*h = (*h << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*h);
	break;

/* rlc_l */
case 0x05:
	carryFlag = *l & 0x80;
	*l = (*l << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*l);
	break;

/* rlc__hl_ */
case 0x06:
	carryFlag = read_byte(*hl) & 0x80;
	write_byte(*hl, (read_byte(*hl) << 1) | (carryFlag ? 0x01 : 0x00));
	do_shift_test(read_byte(*hl));
	break;

/* rlc_a */
case 0x07:
	carryFlag = *a & 0x80;
	*a = (*a << 1) | (carryFlag ? 0x01 : 0x00);
	do_shift_test(*a);
	break;


/* rrc_b */
case 0x08:
	carryFlag = *b & 0x01;
	*b = (*b >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*b);
	break;

/* rrc_c */
case 0x09:
	carryFlag = *c & 0x01;
	*c = (*c >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*c);
	break;

/* rrc_d */
case 0x0A:
	carryFlag = *d & 0x01;
	*d = (*d >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*d);
	break;

/* rrc_e */
case 0x0B:
	carryFlag = *e & 0x01;
	*e = (*e >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*e);
	break;

/* rrc_h */
case 0x0C:
	carryFlag = *h & 0x01;
	*h = (*h >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*h);
	break;

/* rrc_l */
case 0x0D:
	carryFlag = *l & 0x01;
	*l = (*l >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*l);
	break;

/* rrc__hl_ */
case 0x0E:
	carryFlag = read_byte(*hl) & 0x01;
	write_byte(*hl,(read_byte(*hl) >> 1) | (carryFlag ? 0x80 : 0x00));
	do_shift_test(read_byte(*hl));
	break;

/* rrc_a */
case 0x0F:
	carryFlag = *a & 0x01;
	*a = (*a >> 1) | (carryFlag ? 0x80 : 0x00);
	do_shift_test(*a);
	break;


/* rl_b */
case 0x10:
	work8 = *b & 0x80;
	*b = (*b << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8;
	do_shift_test(*b);
	break;

/* rl_c */
case 0x11:
	work8 = *c & 0x80;
	*c = (*c << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*c);
	break;

/* rl_d */
case 0x12:
	work8 = *d & 0x80;
	*d = (*d << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*d);
	break;

/* rl_e */
case 0x13:
	work8 = *e & 0x80;
	*e = (*e << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*e);
	break;

/* rl_h */
case 0x14:
	work8 = *h & 0x80;
	*h = (*h << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*h);
	break;

/* rl_l */
case 0x15:
	work8 = *l & 0x80;
	*l = (*l << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*l);
	break;

/* rl__hl_ */
case 0x16:
	work8 = read_byte(*hl) & 0x80;
	write_byte(*hl,(read_byte(*hl) << 1) | (carryFlag ? 0x01 : 0x00));
	carryFlag = work8; 
	do_shift_test(read_byte(*hl));
	break;

/* rl_a */
case 0x17:
	work8 = *a & 0x80;
	*a = (*a << 1) | (carryFlag ? 0x01 : 0x00);
	carryFlag = work8; 
	do_shift_test(*a);
	break;


/* rr_b */
case 0x18:
	work8 = *b & 0x01;
	*b = (*b >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*b);
	break;

/* rr_c */
case 0x19:
	work8 = *c & 0x01;
	*c = (*c >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*c);
	break;

/* rr_d */
case 0x1A:
	work8 = *d & 0x01;
	*d = (*d >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*d);
	break;

/* rr_e */
case 0x1B:
	work8 = *e & 0x01;
	*e = (*e >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*e);
	break;

/* rr_h */
case 0x1C:
	work8 = *h & 0x01;
	*h = (*h >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*h);
	break;

/* rr_l */
case 0x1D:
	work8 = *l & 0x01;
	*l = (*l >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*l);
	break;

/* rr__hl_ */
case 0x1E:
	work8 = read_byte(*hl) & 0x01;
	write_byte(*hl,(read_byte(*hl) >> 1) | (carryFlag ? 0x80 : 0x00));
	carryFlag = work8; 
	do_shift_test(read_byte(*hl));
	break;

/* rr_a */
case 0x1F:
	work8 = *a & 0x01;
	*a = (*a >> 1) | (carryFlag ? 0x80 : 0x00);
	carryFlag = work8; 
	do_shift_test(*a);
	break;


/* sla_b */
case 0x20:
	carryFlag = *b & 0x80;
	*b <<= 1;
	do_shift_test(*b);
	break;

/* sla_c */
case 0x21:
	carryFlag = *c & 0x80;
	*c <<= 1;
	do_shift_test(*c);
	break;

/* sla_d */
case 0x22:
	carryFlag = *d & 0x80;
	*d <<= 1;
	do_shift_test(*d);
	break;

/* sla_e */
case 0x23:
	carryFlag = *e & 0x80;
	*e <<= 1;
	do_shift_test(*e);
	break;

/* sla_h */
case 0x24:
	carryFlag = *h & 0x80;
	*h <<= 1;
	do_shift_test(*h);
	break;

/* sla_l */
case 0x25:
	carryFlag = *l & 0x80;
	*l <<= 1;
	do_shift_test(*l);
	break;

/* sla__hl_ */
case 0x26:
	carryFlag = read_byte(*hl) & 0x80;
	write_byte(*hl, read_byte(*hl) << 1);
	do_shift_test(read_byte(*hl));
	break;

/* sla_a */
case 0x27:
	carryFlag = *a & 0x80;
	*a <<= 1;
	do_shift_test(*a);
	break;


/* shift right arithmetic operations preserve bit 7 */
/* sra_b */
case 0x28:
	work8 = *b & 0x80;
	carryFlag = *b & 0x01;
	*b = (*b >> 1) | work8;
	do_shift_test(*b);
	break;

/* sra_c */
case 0x29:
	work8 = *c & 0x80;
	carryFlag = *c & 0x01;
	*c = (*c >> 1) | work8;
	do_shift_test(*c);
	break;

/* sra_d */
case 0x2A:
	work8 = *d & 0x80;
	carryFlag = *d & 0x01;
	*d = (*d >> 1) | work8;
	do_shift_test(*d);
	break;

/* sra_e */
case 0x2B:
	work8 = *e & 0x80;
	carryFlag = *e & 0x01;
	*e = (*e >> 1) | work8;
	do_shift_test(*e);
	break;

/* sra_h */
case 0x2C:
	work8 = *h & 0x80;
	carryFlag = *h & 0x01;
	*h = (*h >> 1) | work8;
	do_shift_test(*h);
	break;

/* sra_l */
case 0x2D:
	work8 = *l & 0x80;
	carryFlag = *l & 0x01;
	*l = (*l >> 1) | work8;
	do_shift_test(*l);
	break;

/* sra__hl_ */
case 0x2E:
	work8 = read_byte(*hl) & 0x80;
	carryFlag = read_byte(*hl) & 0x01;
	write_byte(*hl,(read_byte(*hl) >> 1) | work8);
	do_shift_test(read_byte(*hl));
	break;

/* sra_a */
case 0x2F:
	work8 = *a & 0x80;
	carryFlag = *a & 0x01;
	*a = (*a >> 1) | work8;
	do_shift_test(*a);
	break;

/* The next 8 ops. are undocumented. */

/* wsl_b */
case 0x30:
	carryFlag = *b & 0x80;
	*b = (*b << 1) | 0x01;
	do_shift_test(*b);
	break;

/* wsl_c */
case 0x31:
	carryFlag = *c & 0x80;
	*c = (*c << 1) | 0x01;
	do_shift_test(*c);
	break;

/* wsl_d */
case 0x32:
	carryFlag = *d & 0x80;
	*d = (*d << 1) | 0x01;
	do_shift_test(*d);
	break;

/* wsl_e */
case 0x33:
	carryFlag = *e & 0x80;
	*e = (*e << 1) | 0x01;
	do_shift_test(*e);
	break;

/* wsl_h */
case 0x34:
	carryFlag = *h & 0x80;
	*h = (*h << 1) | 0x01;
	do_shift_test(*h);
	break;

/* wsl_l */
case 0x35:
	carryFlag = *l & 0x80;
	*l = (*l << 1) | 0x01;
	do_shift_test(*l);
	break;

/* wsl__hl_ */
case 0x36:
	carryFlag = read_byte(*hl) & 0x80;
	write_byte(*hl, (read_byte(*hl) << 1) | 0x01);
	do_shift_test(read_byte(*hl));
	break;

/* wsl_a */
case 0x37:
	carryFlag = *a & 0x80;
	*a = (*a << 1) | 0x01;
	do_shift_test(*a);
	break;


/* Shift right logical operations: bit 0 -> carry, 0 -> bit 7 */

/* srl_b */
case 0x38:
	carryFlag = *b & 0x01;
	*b >>= 1;
	do_shift_test(*b);
	break;

/* srl_c */
case 0x39:
	carryFlag = *c & 0x01;
	*c >>= 1;
	do_shift_test(*c);
	break;

/* srl_d */
case 0x3A:
	carryFlag = *d & 0x01;
	*d >>= 1;
	do_shift_test(*d);
	break;

/* srl_e */
case 0x3B:
	carryFlag = *e & 0x01;
	*e >>= 1;
	do_shift_test(*e);
	break;

/* srl_h */
case 0x3C:
	carryFlag = *h & 0x01;
	*h >>= 1;
	do_shift_test(*h);
	break;

/* srl_l */
case 0x3D:
	carryFlag = *l & 0x01;
	*l >>= 1;
	do_shift_test(*l);
	break;

/* srl__hl_ */
case 0x3E:
	carryFlag = read_byte(*hl) & 0x01;
	write_byte(*hl, read_byte(*hl) >> 1);
	do_shift_test(read_byte(*hl));
	break;

/* srl_a */
case 0x3F:
	carryFlag = *a & 0x01;
	*a >>= 1;
	do_shift_test(*a);
	break;


/* lots of bit-type things now... */

/* bit_0_b */
case 0x40:
	zeroFlag = !(*b & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_c */
case 0x41:
	zeroFlag = !(*c & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_d */
case 0x42:
	zeroFlag = !(*d & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_e */
case 0x43:
	zeroFlag = !(*e & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_h */
case 0x44:
	zeroFlag = !(*h & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_l */
case 0x45:
	zeroFlag = !(*l & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0__hl_ */
case 0x46:
	zeroFlag = !(read_byte(*hl) & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_0_a */
case 0x47:
	zeroFlag = !(*a & 0x1);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_b */
case 0x48:
	zeroFlag = !(*b & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_c */
case 0x49:
	zeroFlag = !(*c & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_d */
case 0x4A:
	zeroFlag = !(*d & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_e */
case 0x4B:
	zeroFlag = !(*e & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_h */
case 0x4C:
	zeroFlag = !(*h & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_l */
case 0x4D:
	zeroFlag = !(*l & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1__hl_ */
case 0x4E:
	zeroFlag = !(read_byte(*hl) & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_1_a */
case 0x4F:
	zeroFlag = !(*a & 0x2);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_b */
case 0x50:
	zeroFlag = !(*b & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_c */
case 0x51:
	zeroFlag = !(*c & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_d */
case 0x52:
	zeroFlag = !(*d & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_e */
case 0x53:
	zeroFlag = !(*e & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_h */
case 0x54:
	zeroFlag = !(*h & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_l */
case 0x55:
	zeroFlag = !(*l & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2__hl_ */
case 0x56:
	zeroFlag = !(read_byte(*hl) & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_2_a */
case 0x57:
	zeroFlag = !(*a & 0x4);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_b */
case 0x58:
	zeroFlag = !(*b & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_c */
case 0x59:
	zeroFlag = !(*c & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_d */
case 0x5A:
	zeroFlag = !(*d & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_e */
case 0x5B:
	zeroFlag = !(*e & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_h */
case 0x5C:
	zeroFlag = !(*h & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_l */
case 0x5D:
	zeroFlag = !(*l & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3__hl_ */
case 0x5E:
	zeroFlag = !(read_byte(*hl) & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_3_a */
case 0x5F:
	zeroFlag = !(*a & 0x8);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_b */
case 0x60:
	zeroFlag = !(*b & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_c */
case 0x61:
	zeroFlag = !(*c & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_d */
case 0x62:
	zeroFlag = !(*d & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_e */
case 0x63:
	zeroFlag = !(*e & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_h */
case 0x64:
	zeroFlag = !(*h & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_l */
case 0x65:
	zeroFlag = !(*l & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4__hl_ */
case 0x66:
	zeroFlag = !(read_byte(*hl) & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_4_a */
case 0x67:
	zeroFlag = !(*a & 0x10);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_b */
case 0x68:
	zeroFlag = !(*b & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_c */
case 0x69:
	zeroFlag = !(*c & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_d */
case 0x6A:
	zeroFlag = !(*d & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_e */
case 0x6B:
	zeroFlag = !(*e & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_h */
case 0x6C:
	zeroFlag = !(*h & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_l */
case 0x6D:
	zeroFlag = !(*l & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5__hl_ */
case 0x6E:
	zeroFlag = !(read_byte(*hl) & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_5_a */
case 0x6F:
	zeroFlag = !(*a & 0x20);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_b */
case 0x70:
	zeroFlag = !(*b & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_c */
case 0x71:
	zeroFlag = !(*c & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_d */
case 0x72:
	zeroFlag = !(*d & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_e */
case 0x73:
	zeroFlag = !(*e & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_h */
case 0x74:
	zeroFlag = !(*h & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_l */
case 0x75:
	zeroFlag = !(*l & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6__hl_ */
case 0x76:
	zeroFlag = !(read_byte(*hl) & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_6_a */
case 0x77:
	zeroFlag = !(*a & 0x40);
	Set(hcarryFlag); Clr(addsubFlag); Clr(signFlag);
	break;

/* bit_7_b */
case 0x78:
	zeroFlag = !(*b & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *b & 0x80;
	break;

/* bit_7_c */
case 0x79:
	zeroFlag = !(*c & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *c & 0x80;
	break;

/* bit_7_d */
case 0x7A:
	zeroFlag = !(*d & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *d & 0x80;
	break;

/* bit_7_e */
case 0x7B:
	zeroFlag = !(*e & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *e & 0x80;
	break;

/* bit_7_h */
case 0x7C:
	zeroFlag = !(*h & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *h & 0x80;
	break;

/* bit_7_l */
case 0x7D:
	zeroFlag = !(*l & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *l & 0x80;
	break;

/* bit_7__hl_ */
case 0x7E:
	zeroFlag = !(read_byte(*hl) & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = read_byte(*hl) & 0x80;
	break;

/* bit_7_a */
case 0x7F:
	zeroFlag = !(*a & 0x80);
	Set(hcarryFlag); Clr(addsubFlag);
	signFlag = *a & 0x80;
	break;

/* res_0_b */
case 0x80:
	*b &= 0xfe;
	break;

/* res_0_c */
case 0x81:
	*c &= 0xfe;
	break;

/* res_0_d */
case 0x82:
	*d &= 0xfe;
	break;

/* res_0_e */
case 0x83:
	*e &= 0xfe;
	break;

/* res_0_h */
case 0x84:
	*h &= 0xfe;
	break;

/* res_0_l */
case 0x85:
	*l &= 0xfe;
	break;

/* res_0__hl_ */
case 0x86:
	write_byte(*hl, read_byte(*hl) & 0xfe);
	break;

/* res_0_a */
case 0x87:
	*a &= 0xfe;
	break;

/* res_1_b */
case 0x88:
	*b &= 0xfd;
	break;

/* res_1_c */
case 0x89:
	*c &= 0xfd;
	break;

/* res_1_d */
case 0x8A:
	*d &= 0xfd;
	break;

/* res_1_e */
case 0x8B:
	*e &= 0xfd;
	break;

/* res_1_h */
case 0x8C:
	*h &= 0xfd;
	break;

/* res_1_l */
case 0x8D:
	*l &= 0xfd;
	break;

/* res_1__hl_ */
case 0x8E:
	write_byte(*hl, read_byte(*hl) & 0xfd);
	break;

/* res_1_a */
case 0x8F:
	*a &= 0xfd;
	break;

/* res_2_b */
case 0x90:
	*b &= 0xfb;
	break;

/* res_2_c */
case 0x91:
	*c &= 0xfb;
	break;

/* res_2_d */
case 0x92:
	*d &= 0xfb;
	break;

/* res_2_e */
case 0x93:
	*e &= 0xfb;
	break;

/* res_2_h */
case 0x94:
	*h &= 0xfb;
	break;

/* res_2_l */
case 0x95:
	*l &= 0xfb;
	break;

/* res_2__hl_ */
case 0x96:
	write_byte(*hl, read_byte(*hl) & 0xfb);
	break;

/* res_2_a */
case 0x97:
	*a &= 0xfb;
	break;

/* res_3_b */
case 0x98:
	*b &= 0xf7;
	break;

/* res_3_c */
case 0x99:
	*c &= 0xf7;
	break;

/* res_3_d */
case 0x9A:
	*d &= 0xf7;
	break;

/* res_3_e */
case 0x9B:
	*e &= 0xf7;
	break;

/* res_3_h */
case 0x9C:
	*h &= 0xf7;
	break;

/* res_3_l */
case 0x9D:
	*l &= 0xf7;
	break;

/* res_3__hl_ */
case 0x9E:
	write_byte(*hl, read_byte(*hl) & 0xf7);
	break;

/* res_3_a */
case 0x9F:
	*a &= 0xf7;
	break;

/* res_4_b */
case 0xA0:
	*b &= 0xef;
	break;

/* res_4_c */
case 0xA1:
	*c &= 0xef;
	break;

/* res_4_d */
case 0xA2:
	*d &= 0xef;
	break;

/* res_4_e */
case 0xA3:
	*e &= 0xef;
	break;

/* res_4_h */
case 0xA4:
	*h &= 0xef;
	break;

/* res_4_l */
case 0xA5:
	*l &= 0xef;
	break;

/* res_4__hl_ */
case 0xA6:
	write_byte(*hl, read_byte(*hl) & 0xef);
	break;

/* res_4_a */
case 0xA7:
	*a &= 0xef;
	break;

/* res_5_b */
case 0xA8:
	*b &= 0xdf;
	break;

/* res_5_c */
case 0xA9:
	*c &= 0xdf;
	break;

/* res_5_d */
case 0xAA:
	*d &= 0xdf;
	break;

/* res_5_e */
case 0xAB:
	*e &= 0xdf;
	break;

/* res_5_h */
case 0xAC:
	*h &= 0xdf;
	break;

/* res_5_l */
case 0xAD:
	*l &= 0xdf;
	break;

/* res_5__hl_ */
case 0xAE:
	write_byte(*hl, read_byte(*hl) & 0xdf);
	break;

/* res_5_a */
case 0xAF:
	*a &= 0xdf;
	break;

/* res_6_b */
case 0xB0:
	*b &= 0xbf;
	break;

/* res_6_c */
case 0xB1:
	*c &= 0xbf;
	break;

/* res_6_d */
case 0xB2:
	*d &= 0xbf;
	break;

/* res_6_e */
case 0xB3:
	*e &= 0xbf;
	break;

/* res_6_h */
case 0xB4:
	*h &= 0xbf;
	break;

/* res_6_l */
case 0xB5:
	*l &= 0xbf;
	break;

/* res_6__hl_ */
case 0xB6:
	write_byte(*hl, read_byte(*hl) & 0xbf);
	break;

/* res_6_a */
case 0xB7:
	*a &= 0xbf;
	break;

/* res_7_b */
case 0xB8:
	*b &= 0x7f;
	break;

/* res_7_c */
case 0xB9:
	*c &= 0x7f;
	break;

/* res_7_d */
case 0xBA:
	*d &= 0x7f;
	break;

/* res_7_e */
case 0xBB:
	*e &= 0x7f;
	break;

/* res_7_h */
case 0xBC:
	*h &= 0x7f;
	break;

/* res_7_l */
case 0xBD:
	*l &= 0x7f;
	break;

/* res_7__hl_ */
case 0xBE:
	write_byte(*hl, read_byte(*hl) & 0x7f);
	break;

/* res_7_a */
case 0xBF:
	*a &= 0x7f;
	break;

/* set_0_b */
case 0xC0:
	*b |= 0x1;
	break;

/* set_0_c */
case 0xC1:
	*c |= 0x1;
	break;

/* set_0_d */
case 0xC2:
	*d |= 0x1;
	break;

/* set_0_e */
case 0xC3:
	*e |= 0x1;
	break;

/* set_0_h */
case 0xC4:
	*h |= 0x1;
	break;

/* set_0_l */
case 0xC5:
	*l |= 0x1;
	break;

/* set_0__hl_ */
case 0xC6:
	write_byte(*hl, read_byte(*hl) | 0x01);
	break;

/* set_0_a */
case 0xC7:
	*a |= 0x1;
	break;

/* set_1_b */
case 0xC8:
	*b |= 0x2;
	break;

/* set_1_c */
case 0xC9:
	*c |= 0x2;
	break;

/* set_1_d */
case 0xCA:
	*d |= 0x2;
	break;

/* set_1_e */
case 0xCB:
	*e |= 0x2;
	break;

/* set_1_h */
case 0xCC:
	*h |= 0x2;
	break;

/* set_1_l */
case 0xCD:
	*l |= 0x2;
	break;

/* set_1__hl_ */
case 0xCE:
	write_byte(*hl, read_byte(*hl) | 0x02);
	break;

/* set_1_a */
case 0xCF:
	*a |= 0x2;
	break;

/* set_2_b */
case 0xD0:
	*b |= 0x4;
	break;

/* set_2_c */
case 0xD1:
	*c |= 0x4;
	break;

/* set_2_d */
case 0xD2:
	*d |= 0x4;
	break;

/* set_2_e */
case 0xD3:
	*e |= 0x4;
	break;

/* set_2_h */
case 0xD4:
	*h |= 0x4;
	break;

/* set_2_l */
case 0xD5:
	*l |= 0x4;
	break;

/* set_2__hl_ */
case 0xD6:
	write_byte(*hl, read_byte(*hl) | 0x04);
	break;

/* set_2_a */
case 0xD7:
	*a |= 0x4;
	break;

/* set_3_b */
case 0xD8:
	*b |= 0x8;
	break;

/* set_3_c */
case 0xD9:
	*c |= 0x8;
	break;

/* set_3_d */
case 0xDA:
	*d |= 0x8;
	break;

/* set_3_e */
case 0xDB:
	*e |= 0x8;
	break;

/* set_3_h */
case 0xDC:
	*h |= 0x8;
	break;

/* set_3_l */
case 0xDD:
	*l |= 0x8;
	break;

/* set_3__hl_ */
case 0xDE:
	write_byte(*hl, read_byte(*hl) | 0x08);
	break;

/* set_3_a */
case 0xDF:
	*a |= 0x8;
	break;

/* set_4_b */
case 0xE0:
	*b |= 0x10;
	break;

/* set_4_c */
case 0xE1:
	*c |= 0x10;
	break;

/* set_4_d */
case 0xE2:
	*d |= 0x10;
	break;

/* set_4_e */
case 0xE3:
	*e |= 0x10;
	break;

/* set_4_h */
case 0xE4:
	*h |= 0x10;
	break;

/* set_4_l */
case 0xE5:
	*l |= 0x10;
	break;

/* set_4__hl_ */
case 0xE6:
	write_byte(*hl, read_byte(*hl) | 0x10);
	break;

/* set_4_a */
case 0xE7:
	*a |= 0x10;
	break;

/* set_5_b */
case 0xE8:
	*b |= 0x20;
	break;

/* set_5_c */
case 0xE9:
	*c |= 0x20;
	break;

/* set_5_d */
case 0xEA:
	*d |= 0x20;
	break;

/* set_5_e */
case 0xEB:
	*e |= 0x20;
	break;

/* set_5_h */
case 0xEC:
	*h |= 0x20;
	break;

/* set_5_l */
case 0xED:
	*l |= 0x20;
	break;

/* set_5__hl_ */
case 0xEE:
	write_byte(*hl, read_byte(*hl) | 0x20);
	break;

/* set_5_a */
case 0xEF:
	*a |= 0x20;
	break;

/* set_6_b */
case 0xF0:
	*b |= 0x40;
	break;

/* set_6_c */
case 0xF1:
	*c |= 0x40;
	break;

/* set_6_d */
case 0xF2:
	*d |= 0x40;
	break;

/* set_6_e */
case 0xF3:
	*e |= 0x40;
	break;

/* set_6_h */
case 0xF4:
	*h |= 0x40;
	break;

/* set_6_l */
case 0xF5:
	*l |= 0x40;
	break;

/* set_6__hl_ */
case 0xF6:
	write_byte(*hl, read_byte(*hl) | 0x40);
	break;

/* set_6_a */
case 0xF7:
	*a |= 0x40;
	break;

/* set_7_b */
case 0xF8:
	*b |= 0x80;
	break;

/* set_7_c */
case 0xF9:
	*c |= 0x80;
	break;

/* set_7_d */
case 0xFA:
	*d |= 0x80;
	break;

/* set_7_e */
case 0xFB:
	*e |= 0x80;
	break;

/* set_7_h */
case 0xFC:
	*h |= 0x80;
	break;

/* set_7_l */
case 0xFD:
	*l |= 0x80;
	break;

/* set_7__hl_ */
case 0xFE:
	write_byte(*hl, read_byte(*hl) | 0x80);
	break;

/* set_7_a */
case 0xFF:
	*a |= 0x80;
	break;

