/*
 * Copyright (c) Des Herriott 1993, 1994
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 */

/*
 *    Header file cbops.h - declarations for all the Z80 CB-prefix ops.
 */

/* NB. The wsl operations are not normally documented;
 *     in fact wsl is a name I just made up :-)
 */

void
rlc_b(), rlc_c(), rlc_d(), rlc_e(), rlc_h(), rlc_l(), rlc__hl_(), rlc_a(),
rrc_b(), rrc_c(), rrc_d(), rrc_e(), rrc_h(), rrc_l(), rrc__hl_(), rrc_a(),
rl_b(),  rl_c(),  rl_d(),  rl_e(),  rl_h(),  rl_l(),  rl__hl_(),  rl_a(), 
rr_b(),  rr_c(),  rr_d(),  rr_e(),  rr_h(),  rr_l(),  rr__hl_(),  rr_a(), 
sla_b(), sla_c(), sla_d(), sla_e(), sla_h(), sla_l(), sla__hl_(), sla_a(),
sra_b(), sra_c(), sra_d(), sra_e(), sra_h(), sra_l(), sra__hl_(), sra_a(),
wsl_b(), wsl_c(), wsl_d(), wsl_e(), wsl_h(), wsl_l(), wsl__hl_(), wsl_a(),
srl_b(), srl_c(), srl_d(), srl_e(), srl_h(), srl_l(), srl__hl_(), srl_a(),
bit_0_b(), bit_0_c(), bit_0_d(), bit_0_e(), bit_0_h(), bit_0_l(), bit_0__hl_(),
	bit_0_a(),
bit_1_b(), bit_1_c(), bit_1_d(), bit_1_e(), bit_1_h(), bit_1_l(), bit_1__hl_(),
	bit_1_a(),
bit_2_b(), bit_2_c(), bit_2_d(), bit_2_e(), bit_2_h(), bit_2_l(), bit_2__hl_(),
	bit_2_a(),
bit_3_b(), bit_3_c(), bit_3_d(), bit_3_e(), bit_3_h(), bit_3_l(), bit_3__hl_(),
	bit_3_a(),
bit_4_b(), bit_4_c(), bit_4_d(), bit_4_e(), bit_4_h(), bit_4_l(), bit_4__hl_(),
	bit_4_a(),
bit_5_b(), bit_5_c(), bit_5_d(), bit_5_e(), bit_5_h(), bit_5_l(), bit_5__hl_(),
	bit_5_a(),
bit_6_b(), bit_6_c(), bit_6_d(), bit_6_e(), bit_6_h(), bit_6_l(), bit_6__hl_(),
	bit_6_a(),
bit_7_b(), bit_7_c(), bit_7_d(), bit_7_e(), bit_7_h(), bit_7_l(), bit_7__hl_(),
	bit_7_a(),
res_0_b(), res_0_c(), res_0_d(), res_0_e(), res_0_h(), res_0_l(), res_0__hl_(),
	res_0_a(),
res_1_b(), res_1_c(), res_1_d(), res_1_e(), res_1_h(), res_1_l(), res_1__hl_(),
	res_1_a(),
res_2_b(), res_2_c(), res_2_d(), res_2_e(), res_2_h(), res_2_l(), res_2__hl_(),
	res_2_a(),
res_3_b(), res_3_c(), res_3_d(), res_3_e(), res_3_h(), res_3_l(), res_3__hl_(),
	res_3_a(),
res_4_b(), res_4_c(), res_4_d(), res_4_e(), res_4_h(), res_4_l(), res_4__hl_(),
	res_4_a(),
res_5_b(), res_5_c(), res_5_d(), res_5_e(), res_5_h(), res_5_l(), res_5__hl_(),
	res_5_a(),
res_6_b(), res_6_c(), res_6_d(), res_6_e(), res_6_h(), res_6_l(), res_6__hl_(),
	res_6_a(),
res_7_b(), res_7_c(), res_7_d(), res_7_e(), res_7_h(), res_7_l(), res_7__hl_(),
	res_7_a(),
set_0_b(), set_0_c(), set_0_d(), set_0_e(), set_0_h(), set_0_l(), set_0__hl_(),
	set_0_a(),
set_1_b(), set_1_c(), set_1_d(), set_1_e(), set_1_h(), set_1_l(), set_1__hl_(),
	set_1_a(),
set_2_b(), set_2_c(), set_2_d(), set_2_e(), set_2_h(), set_2_l(), set_2__hl_(),
	set_2_a(),
set_3_b(), set_3_c(), set_3_d(), set_3_e(), set_3_h(), set_3_l(), set_3__hl_(),
	set_3_a(),
set_4_b(), set_4_c(), set_4_d(), set_4_e(), set_4_h(), set_4_l(), set_4__hl_(),
	set_4_a(),
set_5_b(), set_5_c(), set_5_d(), set_5_e(), set_5_h(), set_5_l(), set_5__hl_(),
	set_5_a(),
set_6_b(), set_6_c(), set_6_d(), set_6_e(), set_6_h(), set_6_l(), set_6__hl_(),
	set_6_a(),
set_7_b(), set_7_c(), set_7_d(), set_7_e(), set_7_h(), set_7_l(), set_7__hl_(),
	set_7_a();
