/*
 * Copyright (c) Des Herriott 1993, 1994
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 */


#ifndef _XZX_UTIL_H
#define _XZX_UTIL_H

enum { XZX_INFO, XZX_WARN, XZX_ERR, XZX_FATAL };

#ifdef nec_ews
void xzx_mesg();
#else
void xzx_mesg(int error_level, ...);
#endif

FILE *open_xzx_file(char *name, char *mode);

void Quit(int status);
void OnQuit(void (*fn)());

void int_frequency(int ms);
char *req_filename(char *prompt);

#ifdef NEED_STRCASECMP
int strcasecmp(char *s1, char *s2);
int strncasecmp(char *s1, char *s2, int n);
#endif

/* some convenient macros for doing some common Z80 instructions */
#define ret() { *pc = PopValue; }
#define retn() { *pc = PopValue; theProcessor.iff1 = theProcessor.iff2; }
#define scf() { Set(carryFlag); Clr(hcarryFlag); Clr(addsubFlag); }
#define ccf() { Cpl(carryFlag); Clr(addsubFlag); }

#define GET_BASIC_ROM(emode) (emode == 48 ? ROM0 : (emode == 128 ? ROM1 : ROM3))

#endif
