/*
 * Copyright (c) Des Herriott 1993, 1994
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Des Herriott
 */

/*
 * Header file xspec.h - public interface to Spectrum and X11 code.
 */

#ifndef _XZX_XSPEC_H
#define _XZX_XSPEC_H

void start_emulator(int *argcp, char **argvp);
void attr_write(uns16 addr, uns8 val);
void out_byte(uns16 port, uns8 val);
uns8 in_byte(uns16 port);
void do_flashing(void);
void force_screen_refresh(void);

/* a list of actions which can be bound to keypresses */
enum {
	KM_KEMPST_UP, KM_KEMPST_DOWN,
	KM_KEMPST_LEFT, KM_KEMPST_RIGHT,
	KM_KEMPST_FIRE,
#ifdef SLOWDOWN
	KM_KEY_FASTER, KM_KEY_SLOWER,
#endif
	NUM_KEYMAPPINGS
};

#if !defined(SCALING) || (SCALING > 4)
#undef SCALING
#define SCALING 1
#endif

#define BORDER_WIDTH (30 * SCALING)
#define HSize (256 * SCALING)
#define VSize (192 * SCALING)

#ifdef PSEUDO_IO
#define PSEUDO_IO_LOWBYTE 0xbf
#define PSEUDO_STDIN  (0x0000 | PSEUDO_IO_LOWBYTE)
#define PSEUDO_STDOUT (0x0100 | PSEUDO_IO_LOWBYTE)
#define PSEUDO_STDERR (0x0200 | PSEUDO_IO_LOWBYTE)
#endif

#endif
